<?php
namespace Pinpoint\CarouselManager\Block\Adminhtml\Carousel\Edit;

/**
 * Class GenericButton
 * @package Pinpoint\CarouselManager\Block\Adminhtml\Carousel\Edit
 */
class GenericButton
{

    /**
     * @var \Magento\Backend\Block\Widget\Context
     */
    protected $context;

    /**
     * GenericButton constructor.
     *
     * putting all the button methods in here.  No "right", but the whole
     * button/GenericButton thing seems -- not that great -- to begin with
     *
     * @param \Magento\Backend\Block\Widget\Context $context
     */
    public function __construct(
        \Magento\Backend\Block\Widget\Context $context
    ) {
        $this->context = $context;    
    }

    /**
     * @return mixed
     */
    public function getBackUrl()
    {
        return $this->getUrl('*/*/');
    }

    /**
     * @return mixed
     */
    public function getDeleteUrl()
    {
        return $this->getUrl('*/*/delete', ['object_id' => $this->getObjectId()]);
    }

    /**
     * @param string $route
     * @param array $params
     * @return mixed
     */
    public function getUrl($route = '', $params = [])
    {
        return $this->context->getUrlBuilder()->getUrl($route, $params);
    }

    /**
     * @return mixed
     */
    public function getObjectId()
    {
        return $this->context->getRequest()->getParam('carousel_id');
    }     
}
