<?php
namespace Pinpoint\CarouselManager\Controller\Adminhtml\Carousel;

use Magento\Backend\App\Action;
/**
 * Class Itemdelete
 * @package Pinpoint\CarouselManager\Controller\Adminhtml\Carousel
 */
class Itemdelete extends Action
{

    /**
     * Authorization level of a basic admin session
     *
     * @see _isAllowed()
     */
    const ADMIN_RESOURCE = 'Pinpoint_CarouselManager::carousel';

    /**
     * @var \Magento\Framework\Controller\Result\JsonFactory
     */
    protected $resultJsonFactory;

    /**
     * @var \Pinpoint\CarouselManager\Model\CarouselFactory
     */
    protected $carousel;

    /**
     * Itemdelete constructor.
     * @param Action\Context $context
     * @param \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory
     */
    public function __construct(
        Action\Context $context,
        \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
        \Pinpoint\CarouselManager\Model\CarouselFactory $carouselFactory
    ) {
        parent::__construct($context);
        $this->resultJsonFactory = $resultJsonFactory;
        $this->carousel = $carouselFactory;
    }

    /**
     * @return mixed
     */
    public function execute()
    {
        $resultPage = $this->resultJsonFactory->create();

        // check if we know what should be deleted
        $itemId = $this->getRequest()->getParam('itemId');

        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultRedirectFactory->create();

        if ($itemId) {
            try {
                // init model and delete
                $model = $this->carousel;
                $model->load($itemId);
                $model->delete();

                return $resultPage->setData(['success' => true]);

            } catch (\Exception $e) {
                return $resultPage->setData(['success' => false]);
            }
        }

        return $resultPage->setData(['success' => false]);

    }

}
